using System;
using System.Management;
using System.IO;

namespace RemoteDiskSpace
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			ConnectionOptions opt = new ConnectionOptions();
			ObjectQuery oQuery = new ObjectQuery("SELECT Size, FreeSpace, Name, FileSystem FROM Win32_LogicalDisk WHERE DriveType = 3");

			StreamReader oReader = new StreamReader("computers.txt");
			StreamWriter writer = new StreamWriter("diskSpace.html");
			writer.WriteLine("<html><body><table border=\"0\" cellpadding=\"5\">");
			writer.WriteLine(@"<tr>									
									<th>Machine</th>
									<th>Drive</th>
									<th>Size GB</th>
									<th>Free Space GB</th>
									<th>Free Space %</th>
									<th>FileSystem</th>
								</tr>");
			string sLine = String.Empty;

			while (sLine != null)
			{
				sLine = oReader.ReadLine();
				
				if( sLine != null)
				{
					ManagementScope scope = new ManagementScope("\\\\" + sLine + "\\root\\cimv2", opt);

					ManagementObjectSearcher moSearcher = new ManagementObjectSearcher(scope, oQuery);
					ManagementObjectCollection collection = moSearcher.Get();
					writer.WriteLine("<tr><td valign=\"top\">" + sLine + "</td></tr>");
					Console.Write("Trying " + sLine + "...");
					foreach(ManagementObject res in collection)
					{
						decimal size = Convert.ToDecimal(res["Size"])/1024/1024/1024;
						decimal freeSpace = Convert.ToDecimal(res["FreeSpace"])/1024/1024/1024;
						writer.WriteLine("<tr><td></td>");
						writer.WriteLine("<td>" + res["Name"] + "</td>");
						writer.WriteLine("<td>" + Decimal.Round(size, 2) + " GB </td>");
						writer.WriteLine("<td>" + Decimal.Round(freeSpace, 2) + " GB </td>");
						writer.WriteLine("<td>" + Decimal.Round(freeSpace/size, 2)*100 + "% </td>");
						writer.WriteLine("<td>" + res["FileSystem"] + "</td>");
						writer.WriteLine("</tr>");
					}
					Console.WriteLine("done!");
				}

			}
			Console.WriteLine("Please open diskSpace.html for result");
			writer.WriteLine("</table></body></html>");
			writer.Close();
			oReader.Close();

		}
	}
}
